local _, ns = ...; ns.SL_BAGNON = {};

local hook
local _E

local bagFrames = {} -- This is necessary in order to cache the bag frame object class

local function IsBankSlot(bag)
	if type(bag) == "number" then
		if bag == -1 or (bag >= 5 or bag <= 11) then
			return true
		else
			return false
		end
	else
		return false
	end
end

local bagUpdate = function(self)
	if not bagFrames[self] then bagFrames[self] = self end -- Here we cache the bagFrames to ensure our update function works
	if not self:GetVisibleBags() then return end
	for _, bag in self:GetVisibleBags() do
		if not Bagnon:IsBank(bag) and not Bagnon:IsBankBag(bag) then
			local bagSize = self:GetBagSize(bag)
			for slot = 1, bagSize do
				local itemSlot = self:GetItemSlot(bag, slot)
				SyLevel:CallFilters('Bagnonbags', itemSlot, _E and itemSlot:GetItem())
			end
		end
	end
end

local slotUpdate = function(self, msg, bag, slot)
	local itemSlot = self:GetItemSlot(bag, slot)
	if not itemSlot or IsBankSlot(bag) then return end
	SyLevel:CallFilters('Bagnonbags', itemSlot, _E and itemSlot:GetItem())
end


local update = function(self)
	for k, v in pairs(bagFrames) do
		if v then
			bagUpdate(v)
		end
	end
end

local enable = function(self)
	_E = true

	if(not hook) then
		if Bagnon.Bag then
			hooksecurefunc(Bagnon.ItemFrame, "UpdateEverything", bagUpdate)
			hooksecurefunc(Bagnon.ItemFrame, "HandleSpecificItemEvent", slotUpdate)
			hook = true
		end
	end
end

local disable = function(self)
	_E = nil
end

ns.SL_BAGNON.Bagnonbags = function()
	SyLevel:RegisterPipe('Bagnonbags', enable, disable, update, 'Bagnon Bag Window', nil)
end
