-- Special thanks to http://wowinterface.com user "ckaotik" (http://www.wowinterface.com/forums/member.php?u=141999) for getting started on this module.
-- Additional tweaks include:
--	* Changed updating functions and and hooked functions
-- 	* Updated saved variable referencing and preventative re-enabling of pipes on login/reload.

local _, ns = ...
local SL_BAGNON = ns.SL_BAGNON

local f = CreateFrame'frame'
f:RegisterEvent("ADDON_LOADED")

local pipes = {}
local filter = "Item level text"

function f:UpdatePipeStates() -- This was changed to ensure pipes were not reset to enabled
	for k, v in pairs(SyLevelDB.EnabledPipes) do
		if v then
			SyLevel:EnablePipe(k)			
		end
		for filter, enabledPipes in next, SyLevelDB.EnabledFilters do
			if (enabledPipes[k]) then
				SyLevel:RegisterFilterOnPipe(k, filter)
				break
			end
		end
	end
end

function f:CreatePipes()
	if not SyLevel_BagnonDB then SyLevel_BagnonDB = {} end
	for i=1,#pipes do
		SL_BAGNON[pipes[i]]() -- Registers pipes
		if not SyLevel_BagnonDB.initialized then -- Lets not reset the saved variables
			SyLevel:EnablePipe(pipes[i]) -- Automatically Sets the SyLevelDB value for us
			SyLevelDB.EnabledFilters[filter][pipes[i]] = true -- Enable the filter for SyLevelDB
		end
	end
	SyLevel_BagnonDB.initialized = true
	self:UpdatePipeStates()
	wipe(pipes) -- Clean-up for future modules
end

f:SetScript("OnEvent", function(self,event,arg1)
	if arg1 == "SyLevel_Bagnon" then
		if Bagnon:IsFrameEnabled("inventory") then
			tinsert(pipes,"Bagnonbags")
		end
		if Bagnon:IsFrameEnabled("bank") then
			tinsert(pipes,"Bagnonbank")
		end
		self:CreatePipes()
		
	--[[ -- Not ready for realease 
	To Do:
		* Add Below (obviously)
	elseif arg1 == "Bagnon_VoidStorage" then
		tinsert(pipes,"Bagnonvoid")
		self:CreatePipes()
	elseif arg1 == "Bagnon_GuildBank" then
		tinsert(pipes,"Bagnonguild")
		self:CreatePipes()]]
	end
end)
